#include <STC8G.H>
#include "define.h"
#include <intrins.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#define		RXD		P30
#define		TXD		P31
#define		FOSC		11059200UL
#define		BAUD		9600UL
#define		BRT			(0x10000-FOSC/BAUD/4)
#define		R_Buffer_Len	64	//Uart1ջ泤
#define		T_Buffer_Len	64	//Uart1ͻ泤

unsigned char		RP;							//Uart1ָ
unsigned char		TP;							//Uart1ָ
unsigned char		Uart_Send_Lenth;			//Uart1ͳ
unsigned char xdata	R_Buffer[R_Buffer_Len];		//Uart1ջ
unsigned char xdata	T_Buffer[T_Buffer_Len];		//Uart1ͻ

///*----------------------------ʱ10us@STC-Y6@11.0592MHz----------------------------*/
//void Delay_10us(void)
//{
//	unsigned char i;
//	i=35;
//	while(--i);
//}

///*----------------------------ʱx10us----------------------------*/
//void Delay_x10us(unsigned char x)
//{
//	while(x--)
//		Delay_10us();
//}

/*----------------------------ʱ10ms@STC-Y6@11.0592MHz----------------------------*/
void Delay_10ms(void)
{
	unsigned char i,j;
	_nop_();
	_nop_();
	i=144;
	j=157;
	do
	{
		while(--j);
	}while(--i);
}

/*----------------------------ʱx10ms----------------------------*/
void Delay_x10ms(unsigned char x)
{
	while(x--)
		Delay_10ms();
}

void UART_Send(unsigned int x)
{
	TP=0;
	Uart_Send_Lenth=x;
	TI=1;
}

void Uart_Printf(unsigned char *v,...)
{
	va_list ap;
	va_start(ap,v);
	while(Uart_Send_Lenth);
	UART_Send(vsprintf(T_Buffer,v,ap));
	va_end(ap);
}

void Init(void)
{
	P_SW2|=EAXFR;
	
	P3M0=0x00;
	P3M1=0x00;
	
	AUXR=0x40;		//öʱ0ʱΪ12Tģʽöʱ1Ϊ1Tģʽöʱ1Ϊʷ
	TMOD=0x01;		//öʱ0Ϊ16λԶװģʽöʱ1Ϊ16λԶװģʽ
	TL0=0x00;		//öʱ0ʼֵ5ms
	TH0=0xEE;		//öʱ0ʼֵ5ms
	TF0=0;			//TF0жϱ־λ
	ET0=1;			//öʱ0ж
	
	SCON=0x50;		//UART1ģʽΪ8λݿɱ䲨
	TL1=BRT;		//UART1
    TH1=BRT>>8;		//UART1
	TR1=1;			//򿪶ʱ1
	ES=1;			//UART1ж
	
	EA=1;			//ж
}

void main(void)
{
	unsigned int x;
	float pi,pi_last;
	Init();
	x=0;
	pi=0.0F;
	while(1)
	{
		x%2?(pi-=4.0F/((float)x*2.0F+1.0F)):(pi+=4.0F/((float)x*2.0F+1.0F));
		Uart_Printf("x=%U pi=%1.6F\r\n",x,(pi+pi_last)/2);
		pi_last=pi;
		if(x==454)
			while(1);
		x++;
		Delay_x10ms(5);
	}
}

void Uart_Start(void)
{
	TL0=0x00;
	TH0=0xEE;
	TR0=1;
}

void Uart_Stop(void)
{
	TR0=0;
	TL0=0x00;
	TH0=0xEE;
	RP=0;
	memset(R_Buffer,0x00,sizeof R_Buffer);
}

void Timer0_Isr(void) interrupt 1 
{
	Uart_Stop();
}

void Uart_Isr(void) interrupt 4
{
	if(RI)
	{
		RI=0;
		Uart_Start();
		R_Buffer[RP]=SBUF;
		if(RP==R_Buffer_Len-1)
		{
			Uart_Stop();
		}
		else if(TR0)
		{
			RP++;
		}
	}
	if(TI)
	{
		TI=0;
		if(Uart_Send_Lenth!=0)
		{
			SBUF=(T_Buffer[TP]);
			TP++;
		}
		if(TP==Uart_Send_Lenth)
		{
			TP=0;
			Uart_Send_Lenth=0;
		}
	}
}